JUCE: ModifierKeys Class Reference

JUCE

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
ModifierKeys Class Reference

Represents the state of the mouse buttons and modifier keys. More...

## Public Types
enum | Flags { noModifiers = 0, shiftModifier = 1, ctrlModifier = 2, altModifier = 4, leftButtonModifier = 16, rightButtonModifier = 32, middleButtonModifier = 64, commandModifier = 8, popupMenuClickModifier = rightButtonModifier | ctrlModifier, allKeyboardModifiers = shiftModifier | ctrlModifier | altModifier | commandModifier, allMouseButtonModifiers = leftButtonModifier | rightButtonModifier | middleButtonModifier, ctrlAltCommandModifiers = ctrlModifier | altModifier | commandModifier }
| Flags that represent the different keys. More...

## Public Member Functions
| ModifierKeys ()=default
| Creates a ModifierKeys object with no flags set. More...
| ModifierKeys (int flags) noexcept
| Creates a ModifierKeys object from a raw set of flags. More...
| ModifierKeys (const ModifierKeys &)=default
| Creates a copy of another object. More...
ModifierKeys & | operator= (const ModifierKeys &)=default
| Copies this object from another one. More...
bool | isCommandDown () const noexcept
| Checks whether the 'command' key flag is set (or 'ctrl' on Windows/Linux). More...
bool | isPopupMenu () const noexcept
| Checks whether the user is trying to launch a pop-up menu. More...
bool | isLeftButtonDown () const noexcept
| Checks whether the flag is set for the left mouse-button. More...
bool | isRightButtonDown () const noexcept
| Checks whether the flag is set for the right mouse-button. More...
bool | isMiddleButtonDown () const noexcept
bool | isAnyMouseButtonDown () const noexcept
| Tests for any of the mouse-button flags. More...
bool | isAnyModifierKeyDown () const noexcept
| Tests for any of the modifier key flags. More...
bool | isShiftDown () const noexcept
| Checks whether the shift key's flag is set. More...
bool | isCtrlDown () const noexcept
| Checks whether the CTRL key's flag is set. More...
bool | isAltDown () const noexcept
| Checks whether the ALT key's flag is set. More...
ModifierKeys | withOnlyMouseButtons () const noexcept
| Returns a copy of only the mouse-button flags. More...
ModifierKeys | withoutMouseButtons () const noexcept
| Returns a copy of only the non-mouse flags. More...
bool | operator== (const ModifierKeys other) const noexcept
bool | operator!= (const ModifierKeys other) const noexcept
int | getRawFlags () const noexcept
| Returns the raw flags for direct testing. More...
ModifierKeys | withoutFlags (int rawFlagsToClear) const noexcept
ModifierKeys | withFlags (int rawFlagsToSet) const noexcept
bool | testFlags (int flagsToTest) const noexcept
| Tests a combination of flags and returns true if any of them are set. More...
int | getNumMouseButtonsDown () const noexcept
| Returns the total number of mouse buttons that are down. More...

## Static Public Member Functions
static ModifierKeys | getCurrentModifiers () noexcept
| Creates a ModifierKeys object to represent the last-known state of the keyboard and mouse buttons. More...
static ModifierKeys | getCurrentModifiersRealtime () noexcept
| Creates a ModifierKeys object to represent the current state of the keyboard and mouse buttons. More...

## Static Public Attributes
static ModifierKeys | currentModifiers
| This object represents the last-known state of the keyboard and mouse buttons. More...

## Detailed Description

Represents the state of the mouse buttons and modifier keys.

This is used both by mouse events and by KeyPress objects to describe the state of keys such as shift, control, alt, etc.

See also
  KeyPress, MouseEvent::mods

## Member Enumeration Documentation

## ◆ Flags

enum ModifierKeys::Flags

Flags that represent the different keys.

Enumerator
noModifiers | Indicates no modifier keys.
shiftModifier | Shift key flag.
ctrlModifier | CTRL key flag.
altModifier | ALT key flag.
leftButtonModifier | Left mouse button flag.
rightButtonModifier | Right mouse button flag.
middleButtonModifier | Middle mouse button flag.
commandModifier | Command key flag - on windows this is the same as the CTRL key flag.
popupMenuClickModifier | Popup menu flag - on windows this is the same as rightButtonModifier, on the Mac it's the same as (rightButtonModifier | ctrlModifier).
allKeyboardModifiers | Represents a combination of all the shift, alt, ctrl and command key modifiers.
allMouseButtonModifiers | Represents a combination of all the mouse buttons at once.
ctrlAltCommandModifiers | Represents a combination of all the alt, ctrl and command key modifiers.

## Constructor & Destructor Documentation

## ◆ ModifierKeys() [1/3]

ModifierKeys::ModifierKeys | ( |  | ) |
| default

Creates a ModifierKeys object with no flags set.

## ◆ ModifierKeys() [2/3]

ModifierKeys::ModifierKeys | ( | int | flags | ) |
| noexcept

Creates a ModifierKeys object from a raw set of flags.

Parameters

  flags | to represent the keys that are down

See also
  shiftModifier, ctrlModifier, altModifier, leftButtonModifier, rightButtonModifier, commandModifier, popupMenuClickModifier

## ◆ ModifierKeys() [3/3]

ModifierKeys::ModifierKeys | ( | const ModifierKeys & |  | ) |
| default

Creates a copy of another object.

## Member Function Documentation

## ◆ operator=()

ModifierKeys& ModifierKeys::operator= | ( | const ModifierKeys & |  | ) |
| default

Copies this object from another one.

## ◆ isCommandDown()

bool ModifierKeys::isCommandDown | ( |  | ) | const
| noexcept

Checks whether the 'command' key flag is set (or 'ctrl' on Windows/Linux).

This is a platform-agnostic way of checking for the operating system's preferred command-key modifier - so on the Mac it tests for the cmd key, on Windows/Linux, it's actually checking for the CTRL key.

Referenced by SelectedItemSet< SelectableItemType >::addToSelectionBasedOnModifiers(), and LassoComponent< SelectableItemType >::dragLasso().

## ◆ isPopupMenu()

bool ModifierKeys::isPopupMenu | ( |  | ) | const
| noexcept

Checks whether the user is trying to launch a pop-up menu.

This checks for platform-specific modifiers that might indicate that the user is following the operating system's normal method of showing a pop-up menu.

So on Windows/Linux, this method is really testing for a right-click. On the Mac, it tests for either the CTRL key being down, or a right-click.

Referenced by SelectedItemSet< SelectableItemType >::addToSelectionOnMouseDown().

## ◆ isLeftButtonDown()

bool ModifierKeys::isLeftButtonDown | ( |  | ) | const
| noexcept

Checks whether the flag is set for the left mouse-button.

## ◆ isRightButtonDown()

bool ModifierKeys::isRightButtonDown | ( |  | ) | const
| noexcept

Checks whether the flag is set for the right mouse-button.

Note that for detecting popup-menu clicks, you should be using isPopupMenu() instead, as this is platform-independent (and makes your code more explanatory too).

## ◆ isMiddleButtonDown()

bool ModifierKeys::isMiddleButtonDown | ( |  | ) | const
| noexcept

## ◆ isAnyMouseButtonDown()

bool ModifierKeys::isAnyMouseButtonDown | ( |  | ) | const
| noexcept

Tests for any of the mouse-button flags.

## ◆ isAnyModifierKeyDown()

bool ModifierKeys::isAnyModifierKeyDown | ( |  | ) | const
| noexcept

Tests for any of the modifier key flags.

## ◆ isShiftDown()

bool ModifierKeys::isShiftDown | ( |  | ) | const
| noexcept

Checks whether the shift key's flag is set.

Referenced by SelectedItemSet< SelectableItemType >::addToSelectionBasedOnModifiers(), and LassoComponent< SelectableItemType >::dragLasso().

## ◆ isCtrlDown()

bool ModifierKeys::isCtrlDown | ( |  | ) | const
| noexcept

Checks whether the CTRL key's flag is set.

Remember that it's better to use the platform-agnostic routines to test for command-key and popup-menu modifiers.

See also
  isCommandDown, isPopupMenu

## ◆ isAltDown()

bool ModifierKeys::isAltDown | ( |  | ) | const
| noexcept

Checks whether the ALT key's flag is set.

Referenced by LassoComponent< SelectableItemType >::dragLasso().

## ◆ withOnlyMouseButtons()

ModifierKeys ModifierKeys::withOnlyMouseButtons | ( |  | ) | const
| noexcept

Returns a copy of only the mouse-button flags.

## ◆ withoutMouseButtons()

ModifierKeys ModifierKeys::withoutMouseButtons | ( |  | ) | const
| noexcept

Returns a copy of only the non-mouse flags.

## ◆ operator==()

bool ModifierKeys::operator== | ( | const ModifierKeys | other | ) | const
| noexcept

## ◆ operator!=()

bool ModifierKeys::operator!= | ( | const ModifierKeys | other | ) | const
| noexcept

## ◆ getRawFlags()

int ModifierKeys::getRawFlags | ( |  | ) | const
| noexcept

Returns the raw flags for direct testing.

## ◆ withoutFlags()

ModifierKeys ModifierKeys::withoutFlags | ( | int | rawFlagsToClear | ) | const
| noexcept

## ◆ withFlags()

ModifierKeys ModifierKeys::withFlags | ( | int | rawFlagsToSet | ) | const
| noexcept

## ◆ testFlags()

bool ModifierKeys::testFlags | ( | int | flagsToTest | ) | const
| noexcept

Tests a combination of flags and returns true if any of them are set.

## ◆ getNumMouseButtonsDown()

int ModifierKeys::getNumMouseButtonsDown | ( |  | ) | const
| noexcept

Returns the total number of mouse buttons that are down.

## ◆ getCurrentModifiers()

static ModifierKeys ModifierKeys::getCurrentModifiers | ( |  | ) |
| staticnoexcept

Creates a ModifierKeys object to represent the last-known state of the keyboard and mouse buttons.

This method is here for backwards compatibility and there's no need to call it anymore, you should use the public currentModifiers member directly.

## ◆ getCurrentModifiersRealtime()

static ModifierKeys ModifierKeys::getCurrentModifiersRealtime | ( |  | ) |
| staticnoexcept

Creates a ModifierKeys object to represent the current state of the keyboard and mouse buttons.

This method is here for backwards compatibility and you should call ComponentPeer::getCurrentModifiersRealtime() instead (which is what this method now does).

## Member Data Documentation

## ◆ currentModifiers

ModifierKeys ModifierKeys::currentModifiers
| static

This object represents the last-known state of the keyboard and mouse buttons.

The documentation for this class was generated from the following file:

- juce_ModifierKeys.h